v7.3.0

Bryntum Scheduler events in Vue

The Bryntum Scheduler events are passed up to the Vue wrapper which makes it possible to listen to them the standard Vue way.

Listening to events

The following code demonstrates listening to the eventClick event:

Html:

<template>
    <div>
        <bryntum-scheduler
            ref="scheduler"
            @eventclick="onEventClick"
        />
    </div>
</template>

<script>

import { BryntumScheduler } from "@bryntum/scheduler-vue";

export default {

    name: "Scheduler App",

    components: { BryntumScheduler },

    methods : {
        onEventClick() {
            // Do something
        }
   }
}
</script>

Please note that we prefix the capitalized event name with the on keyword and that we pass $event as the argument to the listener.

Preventable events

By returning false from a listener for an event documented as preventable the action that would otherwise be executed after the event is prevented. These events names are usually prefixed with before.

For example:

<template>
    <div>
        <bryntum-scheduler
            ref="scheduler"
            @beforeeventedit="onBeforeEventEdit"
        />
    </div>
</template>

<script>

import { BryntumScheduler } from "@bryntum/scheduler-vue";

export default {

    name: "Scheduler App",

    components: { BryntumScheduler },

    methods : {
        onBeforeEventEdit() {
            if (someCondition) {
                return false;
            }
        }
   }
}
</script>

Contents

v7.3.0

BryntumScheduler events in React

Listening to events

The conventional React way is used to listen to Bryntum Scheduler events. For example, if we want to listen to eventClick event we pass the listener function to onEventClick property. The property name must be in camel case and is case sensitive.

const eventClickHandler = useCallback(({ selection }) => {
    console.log(selection); // actual logic comes here
});

// ...

return (
    <BryntumScheduler
        onEventClick={eventClickHandler}
        // other properties
    />
)

Preventable events

By returning false from a listener for an event documented as preventable the action that would otherwise be executed after the event is prevented. These events names are usually prefixed with before.

For example:

const App = props => {
    function onBeforeEventEdit() {
        if (someCondition) {
            return false;
        }
    }

    return (
        <>
            <BryntumScheduler
                onBeforeEventEdit={onBeforeEventEdit}
            />
        </>
    )
}

Using dataChange event to synchronize data

Bryntum Scheduler keeps all data in its stores which are automatically synchronized with the UI and the user actions. Nevertheless, it is sometimes necessary for the rest of the application to be informed about data changes. For that it is easiest to use dataChange event.

const App = props => {
    const syncData = ({ store, action, records }) => {
        console.log(`${store.id} changed. The action was: ${action}. Changed records: `, records);
        // Your sync data logic comes here
    }

    return (
        <BryntumScheduler
            ref={schedulerRef}
            {...schedulerConfig}
            onDataChange={syncData}
        />
    )
}

You can find details of all events that are fired by BryntumScheduler in the API documentation.

Contents